
/*****************************************
 Primitive 3D double vektor - routines
 (C) Frank A. Natter, Uni. Tuebingen
 Version: 6 Apr 1998
*****************************************/

#define V_ZERO     1E-8
#define V_EQU      1E-10


typedef struct
{
  double x,y,z;
}
VEC;

typedef struct
{
  VEC x,y,z;
}
MATRIX;


/* Bem: die Fkt-Parameter werden der Reihe nach mit a,b,c... */
extern VEC
 v_set(double, double, double),	/*v=(a,b,c)*/
 v_setpol(double,double,double),/*v=(r,th,ph)*/
 v_add(VEC, VEC),		/*v=a+b    */
 v_sub(VEC, VEC),		/*analog   */
 v_smul(double, VEC),		/*v=a*b    */
 v_kreuz(VEC, VEC),		/*v=a^b    */
 v_lgs(MATRIX,VEC),		/*Av=b ->v */
 v_scale(VEC, VEC),		/*vi=ai*bi */
 v_scadd(VEC, VEC, VEC),	/*vi=ai*bi+ci*/
 v_mmul(MATRIX, VEC),		/*v=Ab     */
 v_normal(VEC),			/*v=a/|a|  */
 v_minus(VEC),			/*v=-a     */
 v_perpend(VEC, VEC),		/*senkr-Komponente*/
 v_parallel(VEC, VEC),		/*paralell-Komp.*/
 v_zrotate(VEC,VEC),		/*koordtrafo:b->b' wo a=z-axis*/
 v_polrot(double,double,VEC),	/*rotiere vec um theta,phi in sph. koord*/
 v_polrotinv(double,double,VEC);/*dito, but inverse operation*/
extern double
 v_sprd(VEC,VEC),		/*w=a.b    */
 v_sqr(VEC),			/*w=a.a	   */
 v_det(MATRIX),			/*w=|A|    */
 v_norm(VEC),			/*w=|v|    */
 v_vdet(VEC,VEC, VEC),		/*w=|a,b,c|*/
 v_transverse(VEC);		/*sqrt(x^2+y^2)*/
extern void   v_out(FILE *,char *, VEC),	/*print '%s %vec' in file. Bei file=0->stdout und file neg warten auf Taste*/
              v_cart2pol( VEC, double *, double *, double * );	/* cart vec a -> r, theta, phi (pol coord) */
extern int    v_equ(VEC,VEC),			/*(a-b)^2<V_ZERO  */
              v_lin_rect();			/*v_lin_rect( VEC p,l, q,m,n &r )  Schnitt gerade,ebene*/ 

extern VEC     v_null;
